diff -Nru audiofile-0.2.6/libaudiofile/raw.c audiofile-0.2.7/libaudiofile/raw.c
--- audiofile-0.2.6/libaudiofile/raw.c	2004-03-06 07:39:23.000000000 +0100
+++ audiofile-0.2.7/libaudiofile/raw.c	2010-03-19 04:03:58.000000000 +0100
@@ -39,9 +39,9 @@
 {
 	_AF_VALID_FILESETUP,	/* valid */
 	AF_FILE_RAWDATA,	/* fileFormat */
-	AF_TRUE,		/* trackSet */
-	AF_TRUE,		/* instrumentSet */
-	AF_TRUE,		/* miscellaneousSet */
+	true,			/* trackSet */
+	true,			/* instrumentSet */
+	true,			/* miscellaneousSet */
 	1,			/* trackCount */
 	NULL,			/* tracks */
 	0,			/* instrumentCount */
@@ -50,7 +50,7 @@
 	NULL			/* miscellaneous */
 };
 
-int _af_raw_compression_types[_AF_RAW_NUM_COMPTYPES] =
+const int _af_raw_compression_types[_AF_RAW_NUM_COMPTYPES] =
 {
 	AF_COMPRESSION_G711_ULAW,
 	AF_COMPRESSION_G711_ALAW
@@ -58,7 +58,7 @@
 
 bool _af_raw_recognize (AFvirtualfile *fh)
 {
-	return AF_FALSE;
+	return false;
 }
 
 status _af_raw_read_init (AFfilesetup filesetup, AFfilehandle filehandle)
@@ -103,7 +103,7 @@
 			}
 
 			filesize -= track->fpos_first_frame;
-			track->totalfframes = filesize / _af_format_frame_size(&track->f, AF_FALSE);
+			track->totalfframes = filesize / (int) _af_format_frame_size(&track->f, false);
 		}
 		track->data_size = filesize;
 	}
diff -Nru audiofile-0.2.6/libaudiofile/setup.c audiofile-0.2.7/libaudiofile/setup.c
--- audiofile-0.2.6/libaudiofile/setup.c	2004-03-06 07:39:23.000000000 +0100
+++ audiofile-0.2.7/libaudiofile/setup.c	2010-03-17 09:43:40.000000000 +0100
@@ -39,7 +39,7 @@
 
 extern _Unit _af_units[];
 
-_AFfilesetup _af_default_file_setup =
+const _AFfilesetup _af_default_file_setup =
 {
 	_AF_VALID_FILESETUP,	/* valid */
 #if WORDS_BIGENDIAN
@@ -47,9 +47,9 @@
 #else
 	AF_FILE_WAVE,	/* file format */
 #endif
-	AF_FALSE,	/* trackSet */
-	AF_FALSE,	/* instrumentSet */
-	AF_FALSE,	/* miscellaneousSet */
+	false,		/* trackSet */
+	false,		/* instrumentSet */
+	false,		/* miscellaneousSet */
 	1,		/* trackCount */
 	NULL,		/* tracks */
 	1,		/* instrumentCount */
@@ -58,15 +58,15 @@
 	NULL		/* miscellaneous */
 };
 
-_InstrumentSetup _af_default_instrumentsetup =
+const _InstrumentSetup _af_default_instrumentsetup =
 {
 	0,		/* id */
 	2,		/* loopCount */
 	NULL,		/* loops */
-	AF_FALSE	/* loopSet */
+	false		/* loopSet */
 };
 
-_TrackSetup _af_default_tracksetup =
+const _TrackSetup _af_default_tracksetup =
 {
 	0,
 	{
@@ -83,16 +83,16 @@
 		AF_COMPRESSION_NONE,
 		NULL
 	},
-	AF_FALSE,	/* rateSet */
-	AF_FALSE,	/* sampleFormatSet */
-	AF_FALSE,	/* sampleWidthSet */
-	AF_FALSE,	/* byteOrderSet */
-	AF_FALSE,	/* channelCountSet */
-	AF_FALSE,	/* compressionSet */
-	AF_FALSE,	/* aesDataSet */
-	AF_FALSE,	/* markersSet */
-	AF_FALSE,	/* dataOffsetSet */
-	AF_FALSE,	/* frameCountSet */
+	false,		/* rateSet */
+	false,		/* sampleFormatSet */
+	false,		/* sampleWidthSet */
+	false,		/* byteOrderSet */
+	false,		/* channelCountSet */
+	false,		/* compressionSet */
+	false,		/* aesDataSet */
+	false,		/* markersSet */
+	false,		/* dataOffsetSet */
+	false,		/* frameCountSet */
 
 	4,		/* markerCount */
 	NULL,		/* markers */
@@ -324,7 +324,7 @@
 		return;
 	}
 
-	if (_af_units[filefmt].implemented == AF_FALSE)
+	if (!_af_units[filefmt].implemented)
 	{
 		_af_error(AF_BAD_NOT_IMPLEMENTED,
 			"%s format not currently supported",
@@ -353,7 +353,7 @@
 	}
 
 	track->f.channelCount = channels;
-	track->channelCountSet = AF_TRUE;
+	track->channelCountSet = true;
 }
 
 void afInitSampleFormat (AFfilesetup setup, int trackid, int sampfmt, int sampwidth)
@@ -368,8 +368,8 @@
 
 	_af_set_sample_format(&track->f, sampfmt, sampwidth);
 
-	track->sampleFormatSet = AF_TRUE;
-	track->sampleWidthSet = AF_TRUE;
+	track->sampleFormatSet = true;
+	track->sampleWidthSet = true;
 }
 
 void afInitByteOrder (AFfilesetup setup, int trackid, int byteorder)
@@ -390,7 +390,7 @@
 	}
 
 	track->f.byteOrder = byteorder;
-	track->byteOrderSet = AF_TRUE;
+	track->byteOrderSet = true;
 }
 
 void afInitRate (AFfilesetup setup, int trackid, double rate)
@@ -410,7 +410,7 @@
 	}
 
 	track->f.sampleRate = rate;
-	track->rateSet = AF_TRUE;
+	track->rateSet = true;
 }
 
 /*
@@ -433,7 +433,7 @@
 	}
 
 	track->dataOffset = offset;
-	track->dataOffsetSet = AF_TRUE;
+	track->dataOffsetSet = true;
 }
 
 /*
@@ -456,7 +456,7 @@
 	}
 
 	track->frameCount = count;
-	track->frameCountSet = AF_TRUE;
+	track->frameCountSet = true;
 }
 
 #define alloccopy(type, n, var, copyfrom) \
@@ -521,8 +521,7 @@
 
 		/* XXXmpruett set compression information */
 
-		if (setup->tracks[i].markersSet == AF_FALSE &&
-			copyMarks == AF_FALSE)
+		if (!setup->tracks[i].markersSet && !copyMarks)
 		{
 			track->markers = NULL;
 			track->markerCount = 0;
@@ -649,16 +648,16 @@
 
 			track->hasAESData = tracksetup->aesDataSet;
 
-			track->ms.modulesdirty = AF_TRUE;
+			track->ms.modulesdirty = true;
 			track->ms.nmodules = 0;
 			track->ms.chunk = NULL;
 			track->ms.module = NULL;
 			track->ms.buffer = NULL;
 
-			track->ms.filemodinst.valid = AF_FALSE;
-			track->ms.filemod_rebufferinst.valid = AF_FALSE;
-			track->ms.rateconvertinst.valid = AF_FALSE;
-			track->ms.rateconvert_rebufferinst.valid = AF_FALSE;
+			track->ms.filemodinst.valid = false;
+			track->ms.filemod_rebufferinst.valid = false;
+			track->ms.rateconvertinst.valid = false;
+			track->ms.rateconvert_rebufferinst.valid = false;
 		}
 	}
 
diff -Nru audiofile-0.2.6/libaudiofile/track.c audiofile-0.2.7/libaudiofile/track.c
--- audiofile-0.2.6/libaudiofile/track.c	2004-03-06 07:39:23.000000000 +0100
+++ audiofile-0.2.7/libaudiofile/track.c	2010-03-17 06:31:21.000000000 +0100
@@ -69,7 +69,7 @@
 	t->markerCount = 0;
 	t->markers = NULL;
 
-	t->hasAESData = AF_FALSE;
+	t->hasAESData = false;
 	memset(t->aesData, 0, 24);
 
 	t->totalfframes = 0;
@@ -82,16 +82,16 @@
 	t->nextvframe = 0;
 	t->data_size = 0;
 
-	t->ms.modulesdirty = AF_TRUE;
+	t->ms.modulesdirty = true;
 	t->ms.nmodules = 0;
 	t->ms.chunk = NULL;
 	t->ms.module = NULL;
 	t->ms.buffer = NULL;
 
-	t->ms.filemodinst.valid = AF_FALSE;
-	t->ms.filemod_rebufferinst.valid = AF_FALSE;
-	t->ms.rateconvertinst.valid = AF_FALSE;
-	t->ms.rateconvert_rebufferinst.valid = AF_FALSE;
+	t->ms.filemodinst.valid = false;
+	t->ms.filemod_rebufferinst.valid = false;
+	t->ms.rateconvertinst.valid = false;
+	t->ms.rateconvert_rebufferinst.valid = false;
 
 	return t;
 }
diff -Nru audiofile-0.2.6/libaudiofile/units.c audiofile-0.2.7/libaudiofile/units.c
--- audiofile-0.2.6/libaudiofile/units.c	2004-03-06 07:39:23.000000000 +0100
+++ audiofile-0.2.7/libaudiofile/units.c	2010-03-17 09:43:40.000000000 +0100
@@ -56,12 +56,12 @@
 extern int _af_next_compression_types[];
 extern int _af_wave_compression_types[];
 
-_Unit _af_units[_AF_NUM_UNITS] =
+const _Unit _af_units[_AF_NUM_UNITS] =
 {
 	{
 		AF_FILE_RAWDATA,
 		"Raw Data", "Raw Sound Data", "raw",
-		AF_TRUE, NULL, _af_raw_complete_setup,
+		true, NULL, _af_raw_complete_setup,
 		{_af_raw_recognize, _af_raw_read_init},
 		{_af_raw_write_init, NULL, NULL},
 		AF_SAMPFMT_TWOSCOMP, 16,
@@ -75,7 +75,7 @@
 	{
 		AF_FILE_AIFFC,
 		"AIFF-C", "AIFF-C File Format", "aifc",
-		AF_TRUE, _af_aifc_get_version, _af_aiff_complete_setup,
+		true, _af_aifc_get_version, _af_aiff_complete_setup,
 		{_af_aifc_recognize, _af_aiff_read_init},
 		{_af_aiff_write_init, _af_aiff_instparam_valid, _af_aiff_update},
 		AF_SAMPFMT_TWOSCOMP, 16,
@@ -90,7 +90,7 @@
 	{
 		AF_FILE_AIFF,
 		"AIFF", "Audio Interchange File Format", "aiff",
-		AF_TRUE, NULL, _af_aiff_complete_setup,
+		true, NULL, _af_aiff_complete_setup,
 		{_af_aiff_recognize, _af_aiff_read_init},
 		{_af_aiff_write_init, _af_aiff_instparam_valid, _af_aiff_update},
 		AF_SAMPFMT_TWOSCOMP, 16,
@@ -105,7 +105,7 @@
 	{
 		AF_FILE_NEXTSND,
 		"NeXT .snd/Sun .au", "NeXT .snd/Sun .au Format", "next",
-		AF_TRUE, NULL, _af_next_complete_setup,
+		true, NULL, _af_next_complete_setup,
 		{_af_next_recognize, _af_next_read_init},
 		{_af_next_write_init, NULL, _af_next_update},
 		AF_SAMPFMT_TWOSCOMP, 16,
@@ -119,7 +119,7 @@
 	{
 		AF_FILE_WAVE,
 		"MS RIFF WAVE", "Microsoft RIFF WAVE Format", "wave",
-		AF_TRUE, NULL, _af_wave_complete_setup,
+		true, NULL, _af_wave_complete_setup,
 		{_af_wave_recognize, _af_wave_read_init},
 		{_af_wave_write_init, _af_wave_instparam_valid, _af_wave_update},
 		AF_SAMPFMT_TWOSCOMP, 16,
@@ -134,7 +134,7 @@
 	{
 		AF_FILE_IRCAM,
 		"BICSF", "Berkeley/IRCAM/CARL Sound Format", "bicsf",
-		AF_TRUE, NULL, _af_ircam_complete_setup,
+		true, NULL, _af_ircam_complete_setup,
 		{_af_ircam_recognize, _af_ircam_read_init},
 		{_af_ircam_write_init, NULL, _af_ircam_update},
 		AF_SAMPFMT_TWOSCOMP, 16,
@@ -149,22 +149,22 @@
 	{
 		AF_FILE_MPEG1BITSTREAM,
 		"MPEG", "MPEG Audio Bitstream", "mpeg",
-		AF_FALSE
+		false
 	},
 	{
 		AF_FILE_SOUNDDESIGNER1,
 		"Sound Designer 1", "Sound Designer 1 File Format", "sd1",
-		AF_FALSE
+		false
 	},
 	{
 		AF_FILE_SOUNDDESIGNER2,
 		"Sound Designer 2", "Sound Designer 2 File Format", "sd2",
-		AF_FALSE
+		false
 	},
 	{
 		AF_FILE_AVR,
 		"AVR", "Audio Visual Research File Format", "avr",
-		AF_TRUE, NULL, _af_avr_complete_setup,
+		true, NULL, _af_avr_complete_setup,
 		{_af_avr_recognize, _af_avr_read_init},
 		{_af_avr_write_init, NULL, _af_avr_update},
 		AF_SAMPFMT_TWOSCOMP, 16,
@@ -178,7 +178,7 @@
 	{
 		AF_FILE_IFF_8SVX,
 		"IFF/8SVX", "Amiga IFF/8SVX Sound File Format", "iff",
-		AF_TRUE, NULL, _af_iff_complete_setup,
+		true, NULL, _af_iff_complete_setup,
 		{_af_iff_recognize, _af_iff_read_init},
 		{_af_iff_write_init, NULL, _af_iff_update},
 		AF_SAMPFMT_TWOSCOMP, 8,
@@ -192,17 +192,17 @@
 	{
 		AF_FILE_SAMPLEVISION,
 		"Sample Vision", "Sample Vision File Format", "smp",
-		AF_FALSE
+		false
 	},
 	{
 		AF_FILE_VOC,
 		"VOC", "Creative Voice File Format", "voc",
-		AF_FALSE
+		false
 	},
 	{
 		AF_FILE_NIST_SPHERE,
 		"NIST SPHERE", "NIST SPHERE File Format", "nist",
-		AF_TRUE, NULL, _af_nist_complete_setup,
+		true, NULL, _af_nist_complete_setup,
 		{_af_nist_recognize, _af_nist_read_init},
 		{_af_nist_write_init, NULL, _af_nist_update},
 		AF_SAMPFMT_TWOSCOMP, 16,
@@ -217,74 +217,74 @@
 	{
 		AF_FILE_SOUNDFONT2,
 		"SoundFont 2", "SoundFont 2 File Format", "sf2",
-		AF_FALSE
+		false
 	}
 };
 
-_CompressionUnit _af_compression[_AF_NUM_COMPRESSION] =
+const _CompressionUnit _af_compression[_AF_NUM_COMPRESSION] =
 {
 	{
 		AF_COMPRESSION_NONE,
-		AF_TRUE,
+		true,
 		"none",	/* label */
 		"none",	/* short name */
 		"not compressed",
 		1.0,
 		AF_SAMPFMT_TWOSCOMP, 16,
-		AF_FALSE,	/* needsRebuffer */
-		AF_FALSE,	/* multiple_of */
+		false,	/* needsRebuffer */
+		false,	/* multiple_of */
 		_af_pcm_format_ok,
 		_AFpcminitcompress, _AFpcminitdecompress
 	},
 	{
 		AF_COMPRESSION_G711_ULAW,
-		AF_TRUE,
+		true,
 		"ulaw",	/* label */
 		"CCITT G.711 u-law",	/* shortname */
 		"CCITT G.711 u-law",
 		2.0,
 		AF_SAMPFMT_TWOSCOMP, 16,
-		AF_FALSE,	/* needsRebuffer */
-		AF_FALSE,	/* multiple_of */
+		false,	/* needsRebuffer */
+		false,	/* multiple_of */
 		_af_g711_format_ok,
 		_AFg711initcompress, _AFg711initdecompress
 	},
 	{
 		AF_COMPRESSION_G711_ALAW,
-		AF_TRUE,
+		true,
 		"alaw",	/* label */
 		"CCITT G.711 A-law",	/* short name */
 		"CCITT G.711 A-law",
 		2.0,
 		AF_SAMPFMT_TWOSCOMP, 16,
-		AF_FALSE,	/* needsRebuffer */
-		AF_FALSE,	/* multiple_of */
+		false,	/* needsRebuffer */
+		false,	/* multiple_of */
 		_af_g711_format_ok,
 		_AFg711initcompress, _AFg711initdecompress
 	},
 	{
 		AF_COMPRESSION_IMA,
-		AF_TRUE,
+		true,
 		"ima4",	/* label */
 		"IMA ADPCM",	/* short name */
 		"IMA DVI ADPCM",
 		4.0,
 		AF_SAMPFMT_TWOSCOMP, 16,
-		AF_TRUE,	/* needsRebuffer */
-		AF_FALSE,	/* multiple_of */
+		true,	/* needsRebuffer */
+		false,	/* multiple_of */
 		_af_ima_adpcm_format_ok,
 		NULL, _af_ima_adpcm_init_decompress
 	},
 	{
 		AF_COMPRESSION_MS_ADPCM,
-		AF_TRUE,
+		true,
 		"msadpcm",	/* label */
 		"MS ADPCM",	/* short name */
 		"Microsoft ADPCM",
 		4.0,
 		AF_SAMPFMT_TWOSCOMP, 16,
-		AF_TRUE,	/* needsRebuffer */
-		AF_FALSE,	/* multiple_of */
+		true,	/* needsRebuffer */
+		false,	/* multiple_of */
 		_af_ms_adpcm_format_ok,
 		NULL, _af_ms_adpcm_init_decompress
 	}
diff -Nru audiofile-0.2.6/libaudiofile/util.c audiofile-0.2.7/libaudiofile/util.c
--- audiofile-0.2.6/libaudiofile/util.c	2004-03-06 07:39:23.000000000 +0100
+++ audiofile-0.2.7/libaudiofile/util.c	2010-03-22 06:42:44.000000000 +0100
@@ -46,12 +46,12 @@
 #include "byteorder.h"
 #include "aupvinternal.h"
 
-extern _PCMInfo _af_default_signed_integer_pcm_mappings[];
-extern _PCMInfo _af_default_unsigned_integer_pcm_mappings[];
-extern _PCMInfo _af_default_float_pcm_mapping;
-extern _PCMInfo _af_default_double_pcm_mapping;
+extern const _PCMInfo _af_default_signed_integer_pcm_mappings[];
+extern const _PCMInfo _af_default_unsigned_integer_pcm_mappings[];
+extern const _PCMInfo _af_default_float_pcm_mapping;
+extern const _PCMInfo _af_default_double_pcm_mapping;
 
-extern _CompressionUnit _af_compression[];
+extern const _CompressionUnit _af_compression[];
 
 /*
 	_af_filesetup_ok and _af_filehandle_ok are sanity check routines
@@ -62,14 +62,14 @@
 	if (setup == AF_NULL_FILESETUP)
 	{
 		_af_error(AF_BAD_FILESETUP, "null file setup");
-		return AF_FALSE;
+		return false;
 	}
 	if (setup->valid != _AF_VALID_FILESETUP)
 	{
 		_af_error(AF_BAD_FILESETUP, "invalid file setup");
-		return AF_FALSE;
+		return false;
 	}
-	return AF_TRUE;
+	return true;
 }
 
 bool _af_filehandle_can_read (AFfilehandle file)
@@ -77,10 +77,10 @@
 	if (file->access != _AF_READ_ACCESS)
 	{
 		_af_error(AF_BAD_NOREADACC, "file not opened for read access");
-		return AF_FALSE;
+		return false;
 	}
 
-	return AF_TRUE;
+	return true;
 }
 
 bool _af_filehandle_can_write (AFfilehandle file)
@@ -88,10 +88,10 @@
 	if (file->access != _AF_WRITE_ACCESS)
 	{
 		_af_error(AF_BAD_NOWRITEACC, "file not opened for write access");
-		return AF_FALSE;
+		return false;
 	}
 
-	return AF_TRUE;
+	return true;
 }
 
 bool _af_filehandle_ok (AFfilehandle file)
@@ -99,14 +99,14 @@
 	if (file == AF_NULL_FILEHANDLE)
 	{
 		_af_error(AF_BAD_FILEHANDLE, "null file handle");
-		return AF_FALSE;
+		return false;
 	}
 	if (file->valid != _AF_VALID_FILEHANDLE)
 	{
 		_af_error(AF_BAD_FILEHANDLE, "invalid file handle");
-		return AF_FALSE;
+		return false;
 	}
-	return AF_TRUE;
+	return true;
 }
 
 void *_af_malloc (size_t size)
@@ -231,13 +231,13 @@
 
 		/* Ensure that this parameter is of type AU_PVTYPE_LONG. */
 		if (t != AU_PVTYPE_LONG)
-			return AF_FALSE;
+			return false;
 
 		AUpvgetval(pvlist, i, l);
-		return AF_TRUE;
+		return true;
 	}
 
-	return AF_FALSE;
+	return false;
 }
 
 bool _af_pv_getdouble (AUpvlist pvlist, int param, double *d)
@@ -257,13 +257,13 @@
 
 		/* Ensure that this parameter is of type AU_PVTYPE_DOUBLE. */
 		if (t != AU_PVTYPE_DOUBLE)
-			return AF_FALSE;
+			return false;
 
 		AUpvgetval(pvlist, i, d);
-		return AF_TRUE;
+		return true;
 	}
 
-	return AF_FALSE;
+	return false;
 }
 
 bool _af_pv_getptr (AUpvlist pvlist, int param, void **v)
@@ -283,13 +283,13 @@
 
 		/* Ensure that this parameter is of type AU_PVTYPE_PTR. */
 		if (t != AU_PVTYPE_PTR)
-			return AF_FALSE;
+			return false;
 
 		AUpvgetval(pvlist, i, v);
-		return AF_TRUE;
+		return true;
 	}
 
-	return AF_FALSE;
+	return false;
 }
 
 _TrackSetup *_af_filesetup_get_tracksetup (AFfilesetup setup, int trackid)
@@ -398,7 +398,7 @@
 			f->sampleFormat = sampleFormat;
 			f->sampleWidth = sampleWidth;
 
-			bytes = _af_format_sample_size_uncompressed(f, AF_FALSE);
+			bytes = _af_format_sample_size_uncompressed(f, false);
 
 			if (sampleFormat == AF_SAMPFMT_TWOSCOMP)
 				f->pcm = _af_default_signed_integer_pcm_mappings[bytes];
@@ -444,16 +444,16 @@
 			{
 				_af_error(iderr, "nonunique %s id %d",
 					idname, ids[i]);
-				return AF_FALSE;
+				return false;
 			}
 	}
 
-	return AF_TRUE;
+	return true;
 }
 
-status af_read_uint32_be (u_int32_t *value, AFvirtualfile *vf)
+status af_read_uint32_be (uint32_t *value, AFvirtualfile *vf)
 {
-	u_int32_t	v;
+	uint32_t	v;
 
 	if (af_fread(&v, sizeof (v), 1, vf) != 1)
 		return AF_FAIL;
@@ -461,9 +461,9 @@
 	return AF_SUCCEED;
 }
 
-status af_read_uint32_le (u_int32_t *value, AFvirtualfile *vf)
+status af_read_uint32_le (uint32_t *value, AFvirtualfile *vf)
 {
-	u_int32_t	v;
+	uint32_t	v;
 
 	if (af_fread(&v, sizeof (v), 1, vf) != 1)
 		return AF_FAIL;
@@ -471,9 +471,9 @@
 	return AF_SUCCEED;
 }
 
-status af_read_uint16_be (u_int16_t *value, AFvirtualfile *vf)
+status af_read_uint16_be (uint16_t *value, AFvirtualfile *vf)
 {
-	u_int16_t	v;
+	uint16_t	v;
 
 	if (af_fread(&v, sizeof (v), 1, vf) != 1)
 		return AF_FAIL;
@@ -481,9 +481,9 @@
 	return AF_SUCCEED;
 }
 
-status af_read_uint16_le (u_int16_t *value, AFvirtualfile *vf)
+status af_read_uint16_le (uint16_t *value, AFvirtualfile *vf)
 {
-	u_int16_t	v;
+	uint16_t	v;
 
 	if (af_fread(&v, sizeof (v), 1, vf) != 1)
 		return AF_FAIL;
@@ -491,38 +491,82 @@
 	return AF_SUCCEED;
 }
 
-status af_write_uint32_be (const u_int32_t *value, AFvirtualfile *vf)
+status af_read_uint8 (uint8_t *value, AFvirtualfile *vf)
 {
-	u_int32_t	v;
+	if (af_fread(value, 1, 1, vf) != 1)
+		return AF_FAIL;
+	return AF_SUCCEED;
+}
+
+status af_write_uint32_be (const uint32_t *value, AFvirtualfile *vf)
+{
+	uint32_t	v;
 	v = HOST_TO_BENDIAN_INT32(*value);
 	if (af_fwrite(&v, sizeof (v), 1, vf) != 1)
 		return AF_FAIL;
 	return AF_SUCCEED;
 }
 
-status af_write_uint32_le (const u_int32_t *value, AFvirtualfile *vf)
+status af_write_uint32_le (const uint32_t *value, AFvirtualfile *vf)
 {
-	u_int32_t	v;
+	uint32_t	v;
 	v = HOST_TO_LENDIAN_INT32(*value);
 	if (af_fwrite(&v, sizeof (v), 1, vf) != 1)
 		return AF_FAIL;
 	return AF_SUCCEED;
 }
 
-status af_write_uint16_be (const u_int16_t *value, AFvirtualfile *vf)
+status af_write_uint16_be (const uint16_t *value, AFvirtualfile *vf)
 {
-	u_int16_t	v;
+	uint16_t	v;
 	v = HOST_TO_BENDIAN_INT16(*value);
 	if (af_fwrite(&v, sizeof (v), 1, vf) != 1)
 		return AF_FAIL;
 	return AF_SUCCEED;
 }
 
-status af_write_uint16_le (const u_int16_t *value, AFvirtualfile *vf)
+status af_write_uint16_le (const uint16_t *value, AFvirtualfile *vf)
 {
-	u_int16_t	v;
+	uint16_t	v;
 	v = HOST_TO_LENDIAN_INT16(*value);
 	if (af_fwrite(&v, sizeof (v), 1, vf) != 1)
 		return AF_FAIL;
 	return AF_SUCCEED;
 }
+
+status af_write_uint8 (const uint8_t *value, AFvirtualfile *vf)
+{
+	if (af_fwrite(value, 1, 1, vf) != 1)
+		return AF_FAIL;
+	return AF_SUCCEED;
+}
+
+status af_read_pstring (char s[256], AFvirtualfile *vf)
+{
+	uint8_t length;
+	/* Read the Pascal-style string containing the name. */
+	af_read_uint8(&length, vf);
+	af_fread(s, length, 1, vf);
+	s[length] = '\0';
+	return AF_SUCCEED;
+}
+
+status af_write_pstring (const char *s, AFvirtualfile *vf)
+{
+	size_t length = strlen(s);
+	if (length > 255)
+		return AF_FAIL;
+	uint8_t sizeByte = (uint8_t) length;
+	af_write_uint8(&sizeByte, vf);
+	af_fwrite(s, sizeByte, 1, vf);
+	/*
+		Add a pad byte if the length of the Pascal-style string
+		(including the size byte) is odd.
+	*/
+	if ((length % 2) == 0)
+	{
+		uint8_t zero = 0;
+		af_write_uint8(&zero, vf);
+	}
+	return AF_SUCCEED;
+}
diff -Nru audiofile-0.2.6/libaudiofile/util.h audiofile-0.2.7/libaudiofile/util.h
--- audiofile-0.2.6/libaudiofile/util.h	2004-03-06 07:39:23.000000000 +0100
+++ audiofile-0.2.7/libaudiofile/util.h	2010-03-22 06:42:44.000000000 +0100
@@ -28,7 +28,9 @@
 #ifndef UTIL_H
 #define UTIL_H
 
-#include <sys/types.h>
+#include <stdint.h>
+#include <stdlib.h>
+
 #include "audiofile.h"
 #include "afinternal.h"
 
@@ -65,14 +67,19 @@
 bool _af_filehandle_can_read (AFfilehandle file);
 bool _af_filehandle_can_write (AFfilehandle file);
 
-status af_read_uint32_be (u_int32_t *value, AFvirtualfile *vf);
-status af_read_uint32_le (u_int32_t *value, AFvirtualfile *vf);
-status af_read_uint16_be (u_int16_t *value, AFvirtualfile *vf);
-status af_read_uint16_le (u_int16_t *value, AFvirtualfile *vf);
-
-status af_write_uint32_be (const u_int32_t *value, AFvirtualfile *vf);
-status af_write_uint32_le (const u_int32_t *value, AFvirtualfile *vf);
-status af_write_uint16_be (const u_int16_t *value, AFvirtualfile *vf);
-status af_write_uint16_le (const u_int16_t *value, AFvirtualfile *vf);
+status af_read_uint32_be (uint32_t *value, AFvirtualfile *vf);
+status af_read_uint32_le (uint32_t *value, AFvirtualfile *vf);
+status af_read_uint16_be (uint16_t *value, AFvirtualfile *vf);
+status af_read_uint16_le (uint16_t *value, AFvirtualfile *vf);
+status af_read_uint8 (uint8_t *value, AFvirtualfile *vf);
+
+status af_write_uint32_be (const uint32_t *value, AFvirtualfile *vf);
+status af_write_uint32_le (const uint32_t *value, AFvirtualfile *vf);
+status af_write_uint16_be (const uint16_t *value, AFvirtualfile *vf);
+status af_write_uint16_le (const uint16_t *value, AFvirtualfile *vf);
+status af_write_uint8 (const uint8_t *value, AFvirtualfile *vf);
+
+status af_read_pstring (char value[256], AFvirtualfile *vf);
+status af_write_pstring (const char *value, AFvirtualfile *vf);
 
 #endif
